; ARROW driver

; set arrow type (not used)

setArrowA:	ld	hl, arrowA
		jr	loc_67EC
setArrowB:	ld	hl, arrowB
loc_67EC:	ld	de, (arrowAdr+1)
		ld	(arrowAdr+1), hl
		and	a
		sbc	hl, de
		jr	nz, loc_67FD
		ld	a, (rmArrow)
		and	a
		ret	z
loc_67FD:	call	rmArrow
		jp	drawArrow
		
movArrow:	ld	hl, (arrowXY+1)
		ld	a, 0FAh
		in	a, (0DFh)
		or	7
		inc	a
		jr	nz, loc_684E
loc_680F:	ld	de, 0
		call	getMouseX
		ld	(loc_680F+1), a
		sub	e
		jp	m, loc_6827
		add	a, l
		jr	c, loc_6823
		cp	0FCh
		jr	c, loc_682F
loc_6823:	ld	a, 0FCh
		jr	loc_682F
loc_6827:	neg
		ld	e, a
		ld	a, l
		sub	e
		jr	nc, loc_682F
		xor	a
loc_682F:	ld	l, a
		call	getMouseY
		ld	(loc_680F+2), a
		sub	d
		jp	m, loc_6845
		add	a, h
		jr	c, loc_6841
		cp	0BEh
		jr	c, loc_684D
loc_6841:	ld	a, 0BEh
		jr	loc_684D
loc_6845:	neg
		ld	d, a
		ld	a, h
		sub	d
		jr	nc, loc_684D
		xor	a
loc_684D:	ld	h, a
loc_684E:	push	hl
		call	arrInput
		pop	hl
		ld	d, 2
		bit	1, c
		jr	z, loc_685F
		ld	a, l
		sub	d
		jr	nc, loc_685E
		xor	a
loc_685E:	ld	l, a
loc_685F:	bit	0, c
		jr	z, loc_686E
		ld	a, l
		add	a, d
		jr	c, loc_686B
		cp	0FCh
		jr	c, loc_686D
loc_686B:	ld	a, 0FCh
loc_686D:	ld	l, a
loc_686E:	bit	3, c
		jr	z, loc_6878
		ld	a, h
		sub	d
		jr	nc, loc_6877
		xor	a
loc_6877:	ld	h, a
loc_6878:	bit	2, c
		jr	z, loc_6885
		ld	a, h
		add	a, d
		cp	0BEh
		jr	c, loc_6884
		ld	a, 0BEh
loc_6884:	ld	h, a
loc_6885:	ld	(arrowXYnew+1), hl
		push	bc
		ld	de, (arrowXY+1)
		and	a
		sbc	hl, de
		call	nz, updArrow
		pop	bc
		ld	hl, (arrowXY+1)
		and	a
		bit	4, c
		ret	z
		xor	a
		scf
		ret
		
getMouseX:	ld	a, 0FBh
		in	a, (0DFh)
		ret

getMouseY:	ld	a, 0FFh
		in	a, (0DFh)
		cpl
		add	a, 0C1h
		ret
		
noMove:		push	af
		call	getMouseX
		ld	(loc_680F+1), a
		call	getMouseY
		ld	(loc_680F+2), a
		pop	af
		ret

; update arrow coord

updArrow:	call	rmArrow
arrowXYnew:	ld	hl, 0
		ld	(arrowXY+1), hl
drawArrow:	nop
		xor	a
		call	arrSwap
		ld	bc, (arrowXY+1)
		ld	a, 0C0h
		sub	b
		jr	z, loc_6927
		jr	c, loc_6927
		cp	8
		jr	c, loc_68D9
		ld	a, 8
loc_68D9:	ld	e, a
		call	pt2scr
		ld	b, e
		push	hl
arrowAdr:	ld	hl, arrowA
loc_68E2:	ld	(loc_6920+1), bc
		ld	a, c
		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		inc	hl
		ld	de, 0FFh
		and	7
		jr	z, loc_68FE
loc_68F2:	srl	b
		rr	d
		scf
		rr	c
		rr	e
		dec	a
		jr	nz, loc_68F2
loc_68FE:	ex	(sp), hl
		ld	a, (hl)
		and	c
		or	b
		ld	(hl), a
		ld	a, l
		inc	a
		and	1Fh
		jr	z, loc_690F
		inc	l
		ld	a, (hl)
		and	e
		or	d
		ld	(hl), a
		dec	l
loc_690F:	inc	h
		ld	a, h
		and	7
		jr	nz, loc_691F
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_691F
		ld	a, h
		sub	8
		ld	h, a
loc_691F:	ex	(sp), hl
loc_6920:	ld	bc, 0
		djnz	loc_68E2
		inc	sp
		inc	sp
loc_6927:	ld	a, 0C9h
		ld	(drawArrow), a
		xor	a
		ld	(rmArrow), a
		ret
		
; remove arrow (ret is triggered)

rmArrow:	ret
		ld	a, 0EBh
		call	arrSwap
		xor	a
		ld	(drawArrow), a
		ld	a, 0C9h
		ld	(rmArrow), a
		ret
		
arrSwap:	ld	(loc_6964), a
		ld	(loc_695F), a
arrowXY:	ld	bc, 0
		ld	a, 0C0h
		sub	b
		ret	c
		ret	z
		cp	8
		jr	c, loc_6955
		ld	a, 8
loc_6955:	ld	e, a
		call	pt2scr
		ld	b, e
		ld	de, arrBuffer
		ld	c, 0FFh
loc_695F:	ex	de, hl
		ldi
		ldi
loc_6964:	ex	de, hl
		dec	hl
		dec	hl
		inc	h
		ld	a, h
		and	7
		jr	nz, loc_6977
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_6977
		ld	a, h
		sub	8
		ld	h, a
loc_6977:	djnz	loc_695F
		ret
		
arrInput:	ld	a, 0FAh
		in	a, (0DFh)
		ld	l, a
		or	7
		inc	a
		ld	c, 0
		jr	nz, loc_698C
		rr	l
		jr	c, loc_698C
		ld	c, 10h
loc_698C:	ld	hl, arrKeyTab
		ld	a, 0FEh
		in	a, (0FEh)
		and	1
		jr	nz, loc_699A
		ld	hl,  byte_69F1
loc_699A:	ld	a, (hl)
		and	a
		ret	z
		in	a, (0FEh)
		inc	hl
		and	(hl)
		inc	hl
		jr	nz, loc_69A7
		ld	a, c
		or	(hl)
		ld	c, a
loc_69A7:	inc	hl
		jr	loc_699A
		
; BC = XY (pt.adr) -> HL = scr.adr

pt2scr:		ld	a, b
		and	a
		rra
		scf
		rra
		and	a
		rra
		xor	b
		and	0F8h
		xor	b
		ld	h, a
		ld	a, c
		rlca
		rlca
		rlca
		xor	b
		and	0C7h
		xor	b
		rlca
		rlca
		ld	l, a
		ret

arrowA:		db 0, 0BFh, 40h, 1Fh, 60h, 0Fh, 70h, 7, 78h, 3, 60h, 7, 40h, 1Fh, 0, 0BFh
arrowB:		db 0, 0DFh, 20h, 8Fh, 20h, 87h,	38h, 83h, 7Ch, 1, 7Ch, 1, 38h, 83h, 0, 87h
arrKeyTab:	db 0EFh, 1, 10h
		db 0EFh, 2, 8
		db 0EFh, 4, 4
		db 0EFh, 8, 1
		db 0EFh, 10h, 2
byte_69F1	db 7Fh,	1, 10h
		db 7Fh,	4, 10h
		db 0DFh, 1, 1
		db 0DFh, 2, 2
		db 0FBh, 1, 8
		db 0FDh, 1, 4
		db 0

arrBuffer:	ds 16
