; VQ2 disasm. rampage 3

	MACRO ZONE3 x,dx,y,dy,adr,eadr
	 db x,dx,y,dy
	 dw adr,eadr
	ENDM

exeExt03:	cp	maxExt3func
		ret	nc
		push	hl
		ld	hl, ex3funcTab
		add	a, a
		add	a, l
		ld	l, a
		jr	nc, ex3_C00D
		inc	h
ex3_C00D:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ex	(sp), hl
locret_C012:	ret

ex3funcTab:	dw mainLoop		; 00: start all
		dw finalCut		; 01: finalcut
		dw locret_C012		; 02: nothing ?
		dw drawGameSkin		; 03: draw game skin
		dw arrowControl		; 04: control arrow & click zones
maxExt3func	equ ($ - ex3funcTab) / 2

; main game loop : show title scr, wait keypress, run game, repeat...

mainLoop:	call	flashOff
		call	aniOff
		xor	a
		call	ovEngineFunc
		ld	c, 0
		ld	a, 12h
		call	ovEngineFunc
		ld	hl, pakData1
		ld	de, freeSpace
		call	deHrust2
		call	fBackupScr
		ld	hl, pakData2
		call	depakScreen
		call	flashOn
ex3_C043:	xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	z, ex3_C043
		call	flashOff
		ld	a, 1
		call	ovEngineFunc
		jp	mainLoop

; put game skin, draw item cursor
		
drawGameSkin:	ld	hl, pakData3
		ld	de, freeSpace
		call	deHrust2
		halt
		ld	hl, 5800h
		ld	de, 5801h
		ld	bc, 2FFh
		ld	(hl), l
		ldir
		ld	hl, freeSpace
		ld	de, 4000h
		ld	bc, 1B00h
		ldir
		xor	a
		ld	(curItem), a
		call	xorItemCursor
		ret

arrowControl:	call	fNoKey
		ld	a, 2
		call	ovEngineFunc
loc_E18E:	ld	a, 4
		call	ovEngineFunc
		jr	nc, loc_E18E
		ex	de, hl
		ld	hl, clickZoneTab
loc_E199:	ld	a, (hl)
		and	a
		jr	z, loc_E18E
		ld	a, e
		sub	(hl)
		inc	hl
		cp	(hl)
		inc	hl
		jr	nc, loc_E1AB
		ld	a, d
		sub	(hl)
		inc	hl
		cp	(hl)
		jr	c, loc_E1B3
		dec	hl
loc_E1AB:	inc	hl
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		jr	loc_E199
loc_E1B3:	inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		push	hl
		ld	a, d
		or	e
		ret	z
		ex	de, hl
		push	hl
		call	fArrOff
		pop	hl
		push	hl
		call	pushButton
		halt
		call	fArrOn
		ld	a, 37h
		ld	(arrowFlag), a
loc_E1D3:	halt
		call	arrInput
		ld	a, c
		and	10h
		jr	nz, loc_E1D3
		call	fArrOff
		pop	hl
		jr	popButton

pushButton:	ld	a, h
		or	6
		ld	h, a
		ld	a, l
		add	a, 40h
		ld	l, a
		ld	a, h
		jr	nc, loc_E1F0
		add	a, 8
		ld	h, a
loc_E1F0:	inc	a
		ld	d, a
		ld	e, l
		ld	b, 17h
loc_E1F5:	push	hl
		push	de
		ldi
		ldi
		ldi
		pop	hl
		call	ext3prevHL
		ex	de, hl
		pop	hl
		call	ext3prevHL
		djnz	loc_E1F5
loc_E208:	xor	a
		ld	(de), a
		inc	e
		ld	(de), a
		inc	e
		ld	(de), a
		ret

popButton:	ld	d, h
		ld	e, l
		inc	h
		ld	b, 17h
loc_E214:	push	hl
		push	de
		ldi
		ldi
		ldi
		pop	hl
		call	ext3nextHL
		ex	de, hl
		pop	hl
		call	ext3nextHL
		djnz	loc_E214
		jr	loc_E208

ext3prevHL:	ld	a, h
		dec	h
		and	7
		ret	nz
		ld	a, l
		sub	20h
		ld	l, a
		ret	c
		ld	a, h
		add	a, 8
		ld	h, a
		ret

ext3nextHL:	inc	h
		ld	a, h
		and	7
		ret	nz
		ld	a, l
		add	a, 20h
		ld	l, a
		ret	c
		ld	a, h
		sub	8
		ld	h, a
		ret

; click zones
; x,dx,y,dy, <push.scr.adr>, <exe.adr>
clickZoneTab:	ZONE3 8, 80h, 8, 80h, 0, backToMap ; DATA XREF: RAM:E196o
		ZONE3 98h, 18h, 8, 18h, 4033h,	backToMap
		ZONE3 0B0h, 18h, 8, 18h, 4036h, ext3pdgItem
		ZONE3 0C8h, 18h, 8, 18h, 4039h, ext3useItem
		ZONE3 98h, 18h, 20h, 18h, 4093h, ext3talk
		ZONE3 0B0h, 18h, 20h, 18h, 4096h, ext3fight
		ZONE3 0C8h, 18h, 20h, 18h, 4099h, ext3cast
		ZONE3 0E0h, 18h, 20h, 18h, 409Ch, 6173h
		ZONE3 98h, 18h, 38h, 18h, 0, selSpell1
		ZONE3 0B0h, 18h, 38h, 18h, 0, selSpell2
		ZONE3 0C8h, 18h, 38h, 18h, 0, selSpell3
		ZONE3 0B0h, 10h, 68h, 10h, 0, selectItem0
		ZONE3 0C8h, 10h, 68h, 10h, 0, selectItem1
		ZONE3 0E0h, 10h, 68h, 10h, 0, selectItem2
		db    0

; cast

ext3cast:	ld	a, (spellsCnt)
		and	a
		scf
		ret	z
		ld	a, 6
		jp	ovFuncExt1

; select spell 1,2,3

selSpell1:	ld	b, 1
		jr	selSpellB
selSpell2:	ld	b, 2
		jr	selSpellB
selSpell3:	ld	b, 3
selSpellB:	ld	a, (spellsCnt)
		cp	b
		ret	c
		ld	hl, curSpell
		ld	a, (hl)
		cp	b
		scf
		ret	z
		ld	(hl), b
		ld	a, 2
		call	ovFuncExt1
		scf
		ret

; pick/drop/give

ext3pdgItem:	ld	a, 4
		jp	ovFuncExt1

; use

ext3useItem:	ld	a, 5
		jp	ovFuncExt1

; select item 0,1,2

selectItem0:	ld	c, 0
		jr	selectItemC
selectItem1:	ld	c, 1
		jr	selectItemC
selectItem2:	ld	c, 2
selectItemC:	push	bc
		ld	a, 3		; arrow off
		call	ovEngineFunc	; remove cursor at old pos
		ld	a, (curItem)
		call	xorItemCursor
		pop	bc
		ld	a, c		; set new cursor pos, draw at new pos
		ld	(curItem), a
		call	xorItemCursor
		ld	a, 2
		call	ovEngineFunc
		scf
		ret

; xor item cursor at position A (0,1,2)

xorItemCursor:	ld	hl, loc_E360
		add	a, a
		add	a, l
		ld	l, a
		jr	nc, loc_E319
		inc	h
loc_E319:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		call	udLine
		ld	b, 9
loc_E322:	ld	a, (hl)
		xor	2
		ld	(hl), a
		inc	l
		inc	l
		inc	l
		ld	a, (hl)
		xor	40h
		ld	(hl), a
		call	nextHL
		ld	a, (hl)
		xor	40h
		ld	(hl), a
		dec	l
		dec	l
		dec	l
		ld	a, (hl)
		xor	2
		ld	(hl), a
		call	nextHL
		djnz	loc_E322
udLine:		ld	a, (hl)
		xor	3
		ld	(hl), a
		inc	l
		ld	a, (hl)
		cpl
		ld	(hl), a
		inc	l
		ld	(hl), a
		inc	l
		and	0C0h
		ld	(hl), a
		dec	l
		dec	l
		dec	l
nextHL:		inc	h
		ld	a, h
		and	7
		ret	nz
		ld	a, l
		add	a, 20h
		ld	l, a
		ret	c
		ld	a, h
		sub	8
		ld	h, a
		ret

loc_E360:	dw 0x4e95, 0x4e98, 0x4e9b

; talk, if npc ahead

ext3talk:	ld	b, 0
		ld	a, 6
		call	ovFuncExt0
		ld	b, h
		inc	h
		scf
		ret	z
		ld	a, 3
		jp	ovFuncExt1

; return to map

backToMap:	ld	a, 3
		call	ovEngineFunc
		call	fNoKey
		and	a
		ret

; battle
ext3fight:	ld	a, 7
		jp	ovFuncExt1

; finalcut
		
finalCut:	call	fNoKey
		ld	c, 6		; set music 6
		ld	a, 12h
		call	ovEngineFunc
		ld	hl, pakData4	; finalcut skin
		call	depakScreen
;		ld	hl, locret_E3B9
;		call	sub_E451
		ld	hl, aniData1	; init *.ani
		ld	de, 40C0h
		call	initAni
		ld	hl, byte_F257	; print text
		call	printString
		call	fNoKey		; wait key
		ld	hl, 5800h	; dark
		ld	de, 5801h
		ld	bc, 2FFh
		ld	(hl), l
		ldir
locret_E3B9:	ret

; print string from HL

printString:	ld	a, (hl)
		and	a
		ret	z
		inc	hl
		dec	a
		jr	z, txtc01
		dec	a
		jr	z, txtc02
		sub	1Eh
		cp	60h
		jr	nc, printString
		call	printChar
		jr	printString

; 01,x,y	set print pos

txtc01:		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	(ex3prnPos+1), de
		jr	printString

; 02		wait key

txtc02:		push	hl
loc_E3DA:	halt
		call	playAni
		xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	z, loc_E3DA
loc_E3E6:	halt
		call	playAni
		xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	nz, loc_E3E6
		pop	hl
		jr	printString
; End of function printString

; ---------------------------------------------------------------------------

printChar:				; CODE XREF: printString+10p
		push	bc
		push	de
		push	hl
		ld	l, a
		ld	h, 0
		add	hl, hl
		add	hl, hl
		add	hl, hl
		ld	de, exFont
		add	hl, de
ex3prnPos:	ld	bc, 0
		ld	a, c
		rrca
		rrca
		rrca
		and	0E0h
		or	b
		ld	e, a
		ld	a, c
		and	18h
		or	40h
		ld	d, a
		ld	b, 7
loc_E415:	ld	a, (hl)
		ld	(de), a
		inc	hl
		inc	d
		djnz	loc_E415
		ld	a, d
		rra
		rra
		rra
		and	3
		or	58h
		ld	d, a
		ld	a, 7
		ld	(de), a
		ld	hl,  ex3prnPos+2
		inc	(hl)
		pop	hl
		pop	de
		pop	bc
		ret

depakScreen:	ld	de, freeSpace
		call	deHrust2
		ld	hl, 5800h
		ld	de, 5801h
		ld	bc, 2FFh
		ld	(hl), l
		ldir
		ld	hl, freeSpace
		ld	de, 4000h
		ld	bc, 1B00h
		ldir
		ret

		include "aniplay.asm"
		

; ---------------------------------------------------------------------------

pakData1:	incbin "titleL1.pak"
pakData2:	incbin "titleL2.pak"
pakData3:	incbin "skin.pak"
pakData4:	incbin "finalSkin.pak"
aniData1:	incbin "finalAni.ani"
exFont:		incbin "exfont.bin"

byte_F257:	db 1, 8, 8		; DATA XREF: RAM:E3A4o
		db " holmgard byl oswobovden"
		db 1, 9, 8
		db "------------------------"
		db 1, 0Bh, 8
		db "  ot  spasennyh  vitelej"
		db 1, 0Ch, 8
		db "|gil uznal o dwuh woinah"
		db 1, 0Dh, 8
		db "txmy..."
		db 2, 1, 8, 8
		db "  sej~as bjorn i husgold"
		db 1, 9, 8
		db "pokoqtsq w pe}erah sinih"
		db 1, 0Ah, 8
		db "gor.  oni - edinstwennoe"
		db 1, 0Bh, 8
		db "spasenie ot drakona...  "
		db 1, 0Ch, 8
		db "                        "
		db 1, 0Dh, 8
		db "   i |gil ih obqzatelxno"
		db 1, 0Eh, 8
		db "razy}et..."
		db 2, 1, 8, 8
		db "                        "
		db 1, 9, 8
		db " w sledu`}ej ~asti...   "
		db 1, 0Ah, 8
		db "                        "
		db 1, 0Bh, 8
		db " skoro na |kranah...    "
		db 1, 0Dh, 8
		db "    VIKING QUEST 3      "
		db 1, 0Eh, 8
		db "      woiny txmy        "
		db 2, 0
