#!/bin/sh

mkdir obj

sjasmplus main.asm || exit 1

mhmt -zxh -hst "obj/main.bin" "obj/main.hr1"
mhmt -zxh -hst "obj/page0.bin" "obj/page0.hr1"
mhmt -zxh -hst "obj/page1.bin" "obj/page1.hr1"
mhmt -zxh -hst "obj/page3.bin" "obj/page3.hr1"
#mhmt -zxh -hst "obj/page4.bin" "obj/page4.hr1"		# don't pack music, it's already packed
mhmt -zxh -hst "obj/page6.bin" "obj/page6.hr1"

sjasmplus loader.asm || exit 1

mctrd cscl "VQ2.scl"
mctrd add "obj/boot.bas" "VQ2.scl" -b -a 1
mctrd add "dehr1.6000.bin" "VQ2.scl"
mctrd add "obj/page6.hr1" "VQ2.scl"
mctrd add "obj/page4.bin" "VQ2.scl"
mctrd add "obj/page3.hr1" "VQ2.scl"
mctrd add "obj/page1.hr1" "VQ2.scl"
mctrd add "obj/page0.hr1" "VQ2.scl"
mctrd add "obj/main.hr1" "VQ2.scl"

rm -r obj