	DEVICE ZXSPECTRUM128

dpkAdr	equ 0x6000

	MACRO putFile nm
	 org 0x8000
	 incbin nm
	 align 256
	ENDM

	putFile "obj/main.hr1"
mSec	equ high $ - 0x80

	putFile "obj/page0.hr1"
p0Sec	equ high $ - 0x80

	putFile "obj/page1.hr1"
p1Sec	equ high $ - 0x80

	putFile "obj/page3.hr1"
p3Sec	equ high $ - 0x80

	putFile "obj/page4.bin"
p4Sec	equ high $ - 0x80

	putFile "obj/page6.hr1"
p6Sec	equ high $ - 0x80

	org 23867		; basic start (trdos)
	
bStart	db 0,0		; line 0
	dw l0sz
l0st	db 0xfe		; rem

loader	ld sp,0x5fff
	ld hl,0x4000
	ld de,0x4001
	ld bc,0x1aff
	ld (hl),l
	ldir
	xor a
	out (254),a
	ld hl,dpkAdr
	ld de,0x1002
	call load
	ld de,0x1600 | p6Sec
	call pkC000
	ld hl,0xc000
	ld de,0x1400 | p4Sec
	call load
	ld de,0x1300 | p3Sec
	call pkC000
	ld de,0x1100 | p1Sec
	call pkC000
	ld de,0x1000 | p0Sec
	call pkC000
	ld de,0x1000 | mSec
	ld hl,0x6161
	call pkLoad
	jp 0x6164
	
pkC000	ld hl,0xc000
pkLoad	push hl
	call load
	pop hl
	ld d,h
	ld e,l
	jp dpkAdr
	
load	ld bc,0x7ffd
	out (c),d
	ld b,e
	ld c,5
	ld de,(23796)
	jp 15635

	db 0x0d
l0sz	equ $-l0st

	db 0,1		; line 1
	dw l1sz
l1st	db 0xfd		; clear
	db 0xb0		; val
	db 0x22		; "
	db "24575"
	db 0x22		; "
	db ":"
	db 0xf9		; randomize
	db 0xc0		; usr
	db 0xb0		; val
	db 0x22		; "
	db "23872"
	db 0x22		; "
	db 0x0d
l1sz	equ $-l1st

	savebin "obj/boot.bas",bStart,$-bStart